/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 2);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.types = {
    extLoaded: 'teamious-screen-capture-ext-loaded',
    getScreenSourceId: 'teamious-screen-capture-get-source-id'
};
exports.actions = {
    call: 'teamious-screen-capture-call',
    answer: 'teamious-screen-capture-answer'
};
exports.errors = {
    screenPermissionDeied: 'screenPermissionDeied'
};
function isWellKnownMessage(message) {
    if (!message) {
        return false;
    }
    for (var type in exports.types) {
        if (exports.types[type] === message.type) {
            return true;
        }
    }
    return false;
}
exports.isWellKnownMessage = isWellKnownMessage;


/***/ }),
/* 1 */,
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const Message = __webpack_require__(0);
const screenOptions = ['screen', 'window'];
chrome.runtime.onConnect.addListener(function (port) {
    port.onMessage.addListener(onPortMessage);
    function onPortMessage(message) {
        if (message.action !== Message.actions.call) {
            // Only handles call message.
            return;
        }
        if (message.type === Message.types.getScreenSourceId) {
            chrome.desktopCapture.chooseDesktopMedia(screenOptions, port.sender.tab, sourceId => {
                onMediaChoosen(sourceId, message);
            });
        }
        else {
            console.warn('unknown message', message);
        }
    }
    function onMediaChoosen(sourceId, message) {
        if (!sourceId || !sourceId.length) {
            message.action = Message.actions.answer;
            message.error = Message.errors.screenPermissionDeied;
            return port.postMessage(message);
        }
        message.action = Message.actions.answer;
        message.data = sourceId;
        return port.postMessage(message);
    }
});
chrome.runtime.onInstalled.addListener(function (detail) {
    const manifest = chrome.runtime.getManifest();
    // NOTE(gaolw): only alert can work here, not console.
    // alert('Teamious Screen capture installed.');
    const contentJs = manifest.content_scripts[0].js;
    chrome.windows.getAll({ populate: true }, windows => {
        windows.forEach(window => {
            window.tabs.forEach(tab => {
                //if (!tab.url.match(/(chrome):\/\//gi)) {
                injectContentJsIntoTab(tab, contentJs);
                //}
            });
        });
    });
});
function injectContentJsIntoTab(tab, contentJs) {
    contentJs.forEach(js => {
        chrome.tabs.executeScript(tab.id, {
            file: js
        }, function () {
            if (chrome.runtime.lastError) {
                console.log(chrome.runtime.lastError);
            }
        });
    });
}


/***/ })
/******/ ]);